/*Zgadnienia:
 * Dziedziczenie - polimorfizm
 * Klasa abstrakcyjna

 Opis klas:
 Klasa abstrakcyjna abstr zawiera czyste metody wirtualne: wyswietl,
 wirtualne metody jako przeciazone operatory-- i ++ oraz wirtualny
 zwykly destruktor (wazny dla dziedziczacych obiektow dynamicznych)

 Klasa punkt dziedziczy od klasy abstrakcyjnej abstr i stanowi klase
 wirtualna dla klas: ramka, napis oraz n_ramka jak w lab6_3. Klasa punkt
 posiada nastepujace metody wirtualne przedefiniowane: operatory++ i --
 oraz metode wyswietl dziedziczona przez wszystkie klasy pochodne!.
 Posiada ona wirtualny destruktor, poniewaz klasa bazowa abstr posiada
 destruktor wirtualny!. Pozostale metody wirtualne sa takie same
 jak w LAB11_1 oraz dochodzi metoda wirtualna p_atrybuty dla klasy n_ramka.

 Metody przedefiniowane wirtualne klasy ramka: operatory ++ i --, metody
 dostepu do pol dlugosc i wysokosc oraz metoda rysuj. Klasa ramka ma
 wirtualny destruktor, poniewaz klasa bazowa punkt posiada destruktor
 wirtualny. Klasa ramka posiada niewykorzystane dziedziczone od klasy punkt
 metody wirtualne "dostepu" p_wiersz oraz p_atrybuty oraz
 wykorzystana metode wyswietl.

 Metody przedefiniowane wirtualne klasy napis: operatory ++ i --, metody
 dostepu do pol dlugosc i wiersz oraz metode rysuj. Klasa napis ma
 wirtualny destruktor, poniewaz klasa bazowa punkt posiada destruktor
 wirtualny. Klasa napis posiada nie wykorzystane metody wirtualne
 dziedziczone od klasy punkt: metody "dostepu" p_wysokosc i p_atrybuty
 oraz wykorzystana metode wyswietl.
 Klasa n_ramka dziedziczy bezposrednio od klas ramka i napis.
 Polimorfizm klas punkt, ramka oraz napis jest podobny jak w lab7_1,
 jedynie operatory-- i ++ oraz metoda wyswietl zostaly wirtualnymi
 w klasie praprzodka abstr oraz doszla metoda wirtualna p_atrybuty
 w klasie punkt przedefiniowana w klasie n_ramka.
 Stad klasa n_ramka posiada nastepujace metody wirtualne przedefiniowane:
 operatory++ i --, rysuj, p_atrybuty. Dziedziczy bez przedefiniowania
 metody wirtualne: od klasy punkt: wyswietl, od klasy napis: p_dlugosc,
 p_wiersz, od klasy ramka: p_wysokosc, p_dlugosc. Posiada wirtualny
 destruktor, poniewaz bazowa klasa wirtualna punkt posiada wirtualny
 destruktor.

 Zadania do wykonania:
 1. Wykonaj konstruktory: zwykly i kopiujacy za pomoca listy
    argumentow w klasach punkt, ramka, napis i n_ramka
 2. Wykonaj operatory operator++ oraz operator-- przedrostkowe
    w klasie punkt, ramka, napis oraz n_ramka.
    Metody te powinny zwiekszac lub zmniejszac pola x i y w klasie punkt;
    rozmiar tablicy znakow oraz polozenie napisu na ekranie
    w klasie napis; wspolrzedne x,y polozenia ramki oraz wymiary
    dlugosc i wysokosc w klasie ramka i dodatkowo atrybuty w klasie n_ramka.
    W definicjach operatorow w klasach ramka i napis wykorzystaj
    dziedziczenie operatorow -- oraz ++ od klasy punkt.
    W definicjach operatorow w klasie n_ramka wykorzystaj
    dziedziczenie operatorow -- oraz ++ od klas ramka i napis.
3. Wykonaj pozostale metody na podstawie LAB10\LAB10_2 oraz LAB11\LAB11_1.

Uwagi dotyczace wykonania:
 1. Zabezpiecz pliki naglowkowe punkt7_2.h, ramka7_2.h, napis7_2.h
    oraz nram7_2.h przed wielokrotna deklaracja.
    Uzupelnij pozostale makrodefinicje w plikach naglowkowych.
 2. Wykonaj definicje metod klas punkt, ramka i napis odpowiednio
    w plikach modulowych: punkt7_2.cpp,	ramka7_2.cpp, napis7_2.cpp,
    nram7_2.cpp.Mozna skorzystac z definicji podanych w plikach
    z lab6_3 oraz lab7_1.
 3. Wykonaj projekt zawierajcy: plik lab7_2.cpp, ramka7_2.cpp,
    napis7_2.cpp, nram7_2.cpp. Uzyskany program wykonywalny powinien
    dzialac podobnie jak lab7_2.exe.

Pytania kontrolne:
 1. Wskaz w programie miejsca, wstawiajac w komentarzu dowolne oznaczenia,
    gdzie wykorzystano polimorfizm.
 2. Zakladamy, ze funkcje wyswietl w tym programie sa rownowazne,
    podane jedynie dla zaprezentowania polimorfizmu wspomaganego
    przekazywaniem obiektow przez referencje i wskaznik, stad nalezy
    przyjac, ze mamy jedna funkcje wyswietl w programie. Podaj,
    jakie funkcje musza byc zdefiniowane w programie, aby wyswietlic
    zawartosc wszystkich obiektow z rodziny punkt, gdyby nie zastosowano
    polimorfizmu. Podaj ich liczbe.
 3. Ile nalezaloby zdefiniowac metod wyswietl, aby mozna bylo wyswietlic
    zawartosc wszystkich obiektow w programie, gdyby nie zastosowano
    polimorfizmu?
 4. Podaj kilka przykladowych miejsc w programie, gdzie wystapilyby
    bledy, gdyby usunieto polimorfim. Podaj je za pomoca umownych
    oznaczen w komentarzu umieszczonym we wskazanym miejscu.
 */

#include "nram7_2.h"
#include <iostream.h>
#include <conio.h>
void wyswietl(punkt&, char * kom);
void wyswietl(punkt*, char * kom);
void wyswietl(float, char * kom);
void main()
{ clrscr();
 { n_ramka n_r1(36,5,19,8,"napis w ramce_1",0x3A),
   n_r2(54,3,19,5,"napis w ramce_2",0x1B);
   ramka r1(50,12,10,8),     r2(60,9,10,5);
   napis n1(50,21,"napis1"), n2(63,18,"napis2");
   punkt p1 (2,5),		  p2(2,8);
    getch();
    clrscr();
// Pierwszy sposob -
//  jedna funkcja wywolujaca wirtualne metody, dynamicznie
//  dolaczane przez kompilator zaleznie od podstawionego obiektu
//  przez referencje

    wyswietl(n_r1,"  n_r1\n");
    wyswietl(n_r2,"  n_r2\n");
    wyswietl(r1,"\n  r1\n");
    wyswietl(r2,"\n  r2\n");
    wyswietl(n1,"\n  n1\n");
    wyswietl(n2,"\n  n2\n");
    wyswietl(p1,"\n  p1\n");
    wyswietl(p2,"\n  p2\n");
// Drugi sposob -
//  jedna funkcja wywolujaca wirtualne metody, dynamicznie
//  dolaczane przez kompilator zaleznie od podstawionego obiektu
//  przez wskaznik
 //oraz:
 //przedefiniowane po klasie abstrakcyjnej abstr przeciazone wirtualne
 //metody-operatory++ i -- zdefiniowane za pomoca operatorow ++ i --
 //dziedziczonych od klas punkt, ramka i napis w funkcji wyswietl(&...)(--)

   wyswietl(&n_r1,"  --n_r1\n");
   wyswietl(&r1,"\n  --r1\n");
   wyswietl(&n1,"\n  --n1\n");
   wyswietl(&p1,"\n  --p1\n");
// Trzeci sposob -
// metoda wirtualna w klasie abstrakcyjnej (abstr)
// przedefiniowana jedynie w klasie wirtualnej punkt,
// wywolujaca metody wirtualne dynamicznie dolaczane
// przez kompilator zaleznie od wywolujacego obiektu
 //oraz:
 //przedefiniowane po klasie abstrakcyjnej abstr przeciazone wirtualne
 //metody-operatory++ i -- zdefiniowane za pomoca operatorow ++ i --
 //dziedziczonych od klas punkt, ramka, napis i n_ramka w metodzie wyswietl (++)
   abstr* p;
//pierwsze wywolanie dzieki dziedziczeniu metody wirtualnej wyswietl od
//klasy abstrakcyjnej abstr i przedefiniowaniu w klasie wirtualnej punkt
//drugie wywolanie dzieki dziedziczeniu od klasy wirtualnej punkt
// metody wyswietl

   p=&n_r2;
   p->wyswietl("  ++n_r2\n");
   n_r2.wyswietl("  ++n_r2\n");
   p=&r2;   p->wyswietl("\n  ++r2\n");
   r2.wyswietl("\n  ++r2\n");
   p=&n2;   p->wyswietl("\n  ++n2\n");
   n2.wyswietl("\n  ++n2\n");
   p=&p2;   p->wyswietl("\n  ++p2\n");
   p2.wyswietl("\n  ++p2\n");
//wywolanie metody dziedziczonej odleglosc od klasy punkt
   wyswietl(n_r1.odleglosc(n_r2),"Odleglosc miedzy ramkami z napisem: ");
   wyswietl(r1.odleglosc(r2),"Odleglosc miedzy ramkami: ");
   wyswietl(n1.odleglosc(n2),"Odleglosc miedzy napisami: ");
   wyswietl(p1.odleglosc(p2),"Odleglosc miedzy punktami: ");
   getch();
   clrscr();
   n_r1.rzedna()+=2;  //zmiana wspolrzednej y napisu metoda klasy punkt
   n_r2=n_r1;       //wywolanie przeciazonego
 //operatora = z klasy napis przez domniemany operator =
 // klasy n_ramka
   wyswietl(n_r1.odleglosc(n_r2),"Odleglosc miedzy napisami: ");
   wyswietl(n_r1,"  n_r1\n");
   wyswietl(n_r2,"  n_r2\n");

   n2.rzedna()+=2;  //zmiana wspolrzednej y napisu metoda klasy punkt
   n1=n2;           //wywolanie przeciazonego operatora = z klasy napis
   wyswietl(n1.odleglosc(n2),"Odleglosc miedzy napisami: ");
   wyswietl(n1,"\n  n1\n");
   wyswietl(n2,"\n  n2\n");
   getch();
   clrscr();
 }
}
/* uniwersalna funkcja do wyswietalnia pol calej rodziny obiektow:
   punkt, ramka,  napis, n_ramka dzieki:
 * przekazywaniu przez referencje
 * zastosowaniu polimorfizmu, czyli wywolywaniu metod wirtualnych:
   p_dlugosc, p_wiersz, p_wysokosc, p_atrybuty
 */
void wyswietl(punkt& p, char *kom)
{
 cout << "Atrybuty: " << p.p_atrybuty();
 cout << " Wiersz: " << p.p_wiersz();
 cout << " Dlugosc, Wysokosc: " << p.p_dlugosc() << ", "
			 <<p.p_wysokosc() <<" ";
 cout << " Wspolrzedne: " << p.odcieta() << " "<< p.rzedna() <<kom;
 p.rysuj();
 getch();
 clrscr();
}
/* uniwersalna funkcja do wyswietalnia pol calej rodziny obiektow:
	 punkt, ramka,  napis, n_ramka dzieki:
 * przekazywaniu przez wskaznik
 * zastosowaniu polimorfizmu, czyli wywolywaniu metod wirtualnych:
   p_dlugosc, p_wiersz, p_wysokosc, p_atrybuty i operatora wirtualnego --
*/
void wyswietl(punkt* p, char *kom)
{
 --(*p);
 cout << "Atrybuty: " << (*p).p_atrybuty();
 cout << " Wiersz: " << (*p).p_wiersz();
 cout << " Dlugosc, Wysokosc: " << p->p_dlugosc() << ", "
			 <<p->p_wysokosc() <<" ";
 cout << " Wspolrzedne: " << p->odcieta() << " "<< p->rzedna() <<kom;
 p->rysuj();
 getch();
 clrscr();
}

void wyswietl(float w,char *napis)
{
 cout <<napis<< w << '\n';
 getch();
}

